SDL_timer.h File Reference
`#include <SDL3/SDL_stdinc.h>`
`#include <SDL3/SDL_error.h>`
`#include <SDL3/SDL_begin_code.h>`
`#include <SDL3/SDL_close_code.h>`
Include dependency graph for SDL_timer.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Macros

#define | SDL_MS_PER_SECOND 1000
#define | SDL_US_PER_SECOND 1000000
#define | SDL_NS_PER_SECOND 1000000000LL
#define | SDL_NS_PER_MS 1000000
#define | SDL_NS_PER_US 1000
#define | SDL_SECONDS_TO_NS(S) (((Uint64)(S)) * SDL_NS_PER_SECOND)
#define | SDL_NS_TO_SECONDS(NS) ((NS) / SDL_NS_PER_SECOND)
#define | SDL_MS_TO_NS(MS) (((Uint64)(MS)) * SDL_NS_PER_MS)
#define | SDL_NS_TO_MS(NS) ((NS) / SDL_NS_PER_MS)
#define | SDL_US_TO_NS(US) (((Uint64)(US)) * SDL_NS_PER_US)
#define | SDL_NS_TO_US(NS) ((NS) / SDL_NS_PER_US)

## Typedefs

typedef Uint32 | SDL_TimerID
typedef Uint32(* | SDL_TimerCallback) (void *userdata, SDL_TimerID timerID, Uint32 interval)
typedef Uint64(* | SDL_NSTimerCallback) (void *userdata, SDL_TimerID timerID, Uint64 interval)

## Functions

Uint64 | SDL_GetTicks (void)
Uint64 | SDL_GetTicksNS (void)
Uint64 | SDL_GetPerformanceCounter (void)
Uint64 | SDL_GetPerformanceFrequency (void)
void | SDL_Delay (Uint32 ms)
void | SDL_DelayNS (Uint64 ns)
void | SDL_DelayPrecise (Uint64 ns)
SDL_TimerID | SDL_AddTimer (Uint32 interval, SDL_TimerCallback callback, void *userdata)
SDL_TimerID | SDL_AddTimerNS (Uint64 interval, SDL_NSTimerCallback callback, void *userdata)
bool | SDL_RemoveTimer (SDL_TimerID id)

## Macro Definition Documentation

## SDL_MS_PER_SECOND

#define SDL_MS_PER_SECOND 1000

# CategoryTimer

SDL provides time management functionality. It is useful for dealing with (usually) small durations of time.

This is not to be confused with calendar time management, which is provided by [CategoryTime](CategoryTime).

This category covers measuring time elapsed (SDL_GetTicks(), SDL_GetPerformanceCounter()), putting a thread to sleep for a certain amount of time (SDL_Delay(), SDL_DelayNS(), SDL_DelayPrecise()), and firing a callback function after a certain amount of time has elasped (SDL_AddTimer(), etc).

There are also useful macros to convert between time units, like SDL_SECONDS_TO_NS() and such. Number of milliseconds in a second.

This is always 1000.

Since
  This macro is available since SDL 3.2.0.

Definition at line 62 of file SDL_timer.h.

## SDL_MS_TO_NS

#define SDL_MS_TO_NS | ( |  | MS | ) | (((Uint64)(MS)) * SDL_NS_PER_MS)

Convert milliseconds to nanoseconds.

This only converts whole numbers, not fractional milliseconds.

Parameters

  MS | the number of milliseconds to convert.

Returns
  MS, expressed in nanoseconds.

\threadsafety It is safe to call this macro from any thread.

Since
  This macro is available since SDL 3.2.0.

Definition at line 141 of file SDL_timer.h.

## SDL_NS_PER_MS

#define SDL_NS_PER_MS 1000000

Number of nanoseconds in a millisecond.

This is always 1000000.

Since
  This macro is available since SDL 3.2.0.

Definition at line 89 of file SDL_timer.h.

## SDL_NS_PER_SECOND

#define SDL_NS_PER_SECOND 1000000000LL

Number of nanoseconds in a second.

This is always 1000000000.

Since
  This macro is available since SDL 3.2.0.

Definition at line 80 of file SDL_timer.h.

## SDL_NS_PER_US

#define SDL_NS_PER_US 1000

Number of nanoseconds in a microsecond.

This is always 1000.

Since
  This macro is available since SDL 3.2.0.

Definition at line 98 of file SDL_timer.h.

## SDL_NS_TO_MS

#define SDL_NS_TO_MS | ( |  | NS | ) | ((NS) / SDL_NS_PER_MS)

Convert nanoseconds to milliseconds.

This performs a division, so the results can be dramatically different if `NS` is an integer or floating point value.

Parameters

  NS | the number of nanoseconds to convert.

Returns
  NS, expressed in milliseconds.

\threadsafety It is safe to call this macro from any thread.

Since
  This macro is available since SDL 3.2.0.

Definition at line 156 of file SDL_timer.h.

## SDL_NS_TO_SECONDS

#define SDL_NS_TO_SECONDS | ( |  | NS | ) | ((NS) / SDL_NS_PER_SECOND)

Convert nanoseconds to seconds.

This performs a division, so the results can be dramatically different if `NS` is an integer or floating point value.

Parameters

  NS | the number of nanoseconds to convert.

Returns
  NS, expressed in seconds.

\threadsafety It is safe to call this macro from any thread.

Since
  This macro is available since SDL 3.2.0.

Definition at line 127 of file SDL_timer.h.

## SDL_NS_TO_US

#define SDL_NS_TO_US | ( |  | NS | ) | ((NS) / SDL_NS_PER_US)

Convert nanoseconds to microseconds.

This performs a division, so the results can be dramatically different if `NS` is an integer or floating point value.

Parameters

  NS | the number of nanoseconds to convert.

Returns
  NS, expressed in microseconds.

\threadsafety It is safe to call this macro from any thread.

Since
  This macro is available since SDL 3.2.0.

Definition at line 185 of file SDL_timer.h.

## SDL_SECONDS_TO_NS

#define SDL_SECONDS_TO_NS | ( |  | S | ) | (((Uint64)(S)) * SDL_NS_PER_SECOND)

Convert seconds to nanoseconds.

This only converts whole numbers, not fractional seconds.

Parameters

  S | the number of seconds to convert.

Returns
  S, expressed in nanoseconds.

\threadsafety It is safe to call this macro from any thread.

Since
  This macro is available since SDL 3.2.0.

Definition at line 112 of file SDL_timer.h.

## SDL_US_PER_SECOND

#define SDL_US_PER_SECOND 1000000

Number of microseconds in a second.

This is always 1000000.

Since
  This macro is available since SDL 3.2.0.

Definition at line 71 of file SDL_timer.h.

## SDL_US_TO_NS

#define SDL_US_TO_NS | ( |  | US | ) | (((Uint64)(US)) * SDL_NS_PER_US)

Convert microseconds to nanoseconds.

This only converts whole numbers, not fractional microseconds.

Parameters

  US | the number of microseconds to convert.

Returns
  US, expressed in nanoseconds.

\threadsafety It is safe to call this macro from any thread.

Since
  This macro is available since SDL 3.2.0.

Definition at line 170 of file SDL_timer.h.

## Typedef Documentation

## SDL_NSTimerCallback

typedef Uint64(* SDL_NSTimerCallback) (void *userdata, SDL_TimerID timerID, Uint64 interval)

Function prototype for the nanosecond timer callback function.

The callback function is passed the current timer interval and returns the next timer interval, in nanoseconds. If the returned value is the same as the one passed in, the periodic alarm continues, otherwise a new alarm is scheduled. If the callback returns 0, the periodic alarm is canceled and will be removed.

Parameters

  userdata | an arbitrary pointer provided by the app through SDL_AddTimer, for its own use.
  timerID | the current timer being processed.
  interval | the current callback time interval.

Returns
  the new callback time interval, or 0 to disable further runs of the callback.

\threadsafety SDL may call this callback at any time from a background thread; the application is responsible for locking resources the callback touches that need to be protected.

Since
  This datatype is available since SDL 3.2.0.

See also
  SDL_AddTimerNS

Definition at line 390 of file SDL_timer.h.

## SDL_TimerCallback

typedef Uint32(* SDL_TimerCallback) (void *userdata, SDL_TimerID timerID, Uint32 interval)

Function prototype for the millisecond timer callback function.

The callback function is passed the current timer interval and returns the next timer interval, in milliseconds. If the returned value is the same as the one passed in, the periodic alarm continues, otherwise a new alarm is scheduled. If the callback returns 0, the periodic alarm is canceled and will be removed.

Parameters

  userdata | an arbitrary pointer provided by the app through SDL_AddTimer, for its own use.
  timerID | the current timer being processed.
  interval | the current callback time interval.

Returns
  the new callback time interval, or 0 to disable further runs of the callback.

\threadsafety SDL may call this callback at any time from a background thread; the application is responsible for locking resources the callback touches that need to be protected.

Since
  This datatype is available since SDL 3.2.0.

See also
  SDL_AddTimer

Definition at line 328 of file SDL_timer.h.

## SDL_TimerID

typedef Uint32 SDL_TimerID

Definition of the timer ID type.

Since
  This datatype is available since SDL 3.2.0.

Definition at line 302 of file SDL_timer.h.

## Function Documentation

## SDL_AddTimer()

SDL_TimerID SDL_AddTimer | ( | Uint32 | interval,
|  | SDL_TimerCallback | callback,
|  | void * | userdata
| ) |  |

extern

Call a callback function at a future time.

The callback function is passed the current timer interval and the user supplied parameter from the SDL_AddTimer() call and should return the next timer interval. If the value returned from the callback is 0, the timer is canceled and will be removed.

The callback is run on a separate thread, and for short timeouts can potentially be called before this function returns.

Timers take into account the amount of time it took to execute the callback. For example, if the callback took 250 ms to execute and returned 1000 (ms), the timer would only wait another 750 ms before its next iteration.

Timing may be inexact due to OS scheduling. Be sure to note the current time with SDL_GetTicksNS() or SDL_GetPerformanceCounter() in case your callback needs to adjust for variances.

Parameters

  interval | the timer delay, in milliseconds, passed to `callback`.
  callback | the SDL_TimerCallback function to call when the specified `interval` elapses.
  userdata | a pointer that is passed to `callback`.

Returns
  a timer ID or 0 on failure; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_AddTimerNS
  SDL_RemoveTimer

## SDL_AddTimerNS()

SDL_TimerID SDL_AddTimerNS | ( | Uint64 | interval,
|  | SDL_NSTimerCallback | callback,
|  | void * | userdata
| ) |  |

extern

Call a callback function at a future time.

The callback function is passed the current timer interval and the user supplied parameter from the SDL_AddTimerNS() call and should return the next timer interval. If the value returned from the callback is 0, the timer is canceled and will be removed.

The callback is run on a separate thread, and for short timeouts can potentially be called before this function returns.

Timers take into account the amount of time it took to execute the callback. For example, if the callback took 250 ns to execute and returned 1000 (ns), the timer would only wait another 750 ns before its next iteration.

Timing may be inexact due to OS scheduling. Be sure to note the current time with SDL_GetTicksNS() or SDL_GetPerformanceCounter() in case your callback needs to adjust for variances.

Parameters

  interval | the timer delay, in nanoseconds, passed to `callback`.
  callback | the SDL_TimerCallback function to call when the specified `interval` elapses.
  userdata | a pointer that is passed to `callback`.

Returns
  a timer ID or 0 on failure; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_AddTimer
  SDL_RemoveTimer

## SDL_Delay()

void SDL_Delay | ( | Uint32 | ms | ) |

extern

Wait a specified number of milliseconds before returning.

This function waits a specified number of milliseconds before returning. It waits at least the specified time, but possibly longer due to OS scheduling.

Parameters

  ms | the number of milliseconds to delay.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_DelayNS
  SDL_DelayPrecise

## SDL_DelayNS()

void SDL_DelayNS | ( | Uint64 | ns | ) |

extern

Wait a specified number of nanoseconds before returning.

This function waits a specified number of nanoseconds before returning. It waits at least the specified time, but possibly longer due to OS scheduling.

Parameters

  ns | the number of nanoseconds to delay.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_Delay
  SDL_DelayPrecise

## SDL_DelayPrecise()

void SDL_DelayPrecise | ( | Uint64 | ns | ) |

extern

Wait a specified number of nanoseconds before returning.

This function waits a specified number of nanoseconds before returning. It will attempt to wait as close to the requested time as possible, busy waiting if necessary, but could return later due to OS scheduling.

Parameters

  ns | the number of nanoseconds to delay.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_Delay
  SDL_DelayNS

## SDL_GetPerformanceCounter()

Uint64 SDL_GetPerformanceCounter | ( | void |  | ) |

extern

Get the current value of the high resolution counter.

This function is typically used for profiling.

The counter values are only meaningful relative to each other. Differences between values can be converted to times by using SDL_GetPerformanceFrequency().

Returns
  the current counter value.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetPerformanceFrequency

## SDL_GetPerformanceFrequency()

Uint64 SDL_GetPerformanceFrequency | ( | void |  | ) |

extern

Get the count per second of the high resolution counter.

Returns
  a platform-specific count per second.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetPerformanceCounter

## SDL_GetTicks()

Uint64 SDL_GetTicks | ( | void |  | ) |

extern

Get the number of milliseconds since SDL library initialization.

Returns
  an unsigned 64-bit value representing the number of milliseconds since the SDL library initialized.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_GetTicksNS()

Uint64 SDL_GetTicksNS | ( | void |  | ) |

extern

Get the number of nanoseconds since SDL library initialization.

Returns
  an unsigned 64-bit value representing the number of nanoseconds since the SDL library initialized.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_RemoveTimer()

bool SDL_RemoveTimer | ( | SDL_TimerID | id | ) |

extern

Remove a timer created with SDL_AddTimer().

Parameters

  id | the ID of the timer to remove.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_AddTimer